!**************************************************************************
!*                          NEW-TECH TSR SENTRY                           *
!**************************************************************************


         MODULE('Sentry')

                   Sentry(SHORT,SHORT),SHORT,NAME('_Sentry')

         OMIT('!***')

                Use this function to directly communicate with the tsr.
                Usage:
                        Sentry(ACTION,SETTING)

                eg:
                ==>     Sentry(DISABLE_CTRL_ALT_DEL,YES)
                        (ctrl-alt-delete will be disabled)

                        Sentry(DISABLE_CTRL_ALT_DEL,NO)
                        (allow ctrl-alt-delete)

                ==>     Sentry(DISABLE_CTRL_BREAK,YES)
                        (disable ctrl-break/ctrl-C)

                        Sentry(DISABLE_CTRL_BREAK,NO)
                        (enable ctrl-break/ctrl-C)

                ==>     Sentry(ARE_YOU_THERE,0)
                        (returns IM_HERE if tsr loaded)

                ==>     Sentry(DENY_DOS_ACCESS,YES)
                        (Detects whether a user is at the dos prompt
                        and takes action. Action taken depends on the
                        following protection settings. Default action
                        is to shove the command "EXIT" into the
                        keyboard buffer forcing the user to return to
                        the app that did the shelling. Dos protect
                        does not work with all programs. You may have
                        to adjust the sensitivity or disable the
                        protection with those programs.)

                        Sentry(DENY_DOS_ACCESS,NO)
                        (disable checking)

                =>      Sentry(LOCK_KEYBOARD_IN_DOS,YES)
                        (DENY_DOS_ACCESS must be set to YES for this
                        directive to have any meaning. If the user
                        is in dos then LOCK the computer forcing
                        the user to press RESET to regain control.)

                =>      Sentry(LOCK_KEYBOARD_IN_DOS,NO) ***DEFAULT
                        (SHOVE the "EXIT" command in the keyboard buffer
                        when a user is in DOS. this is the default setting)

                =>      Sentry(SET_PROTECTION_SENSITIVITY,xx)
                        (where xx is a value between 1 and 254.
                        1=extremely sensitive, 254=dead to the world

                        Use this directive to set how sensitive the tsr
                        is with programs. Some programs that work closely
                        with dos will require a higher setting; Others will
                        not. The default setting of 3 works well and is
                        recommended. You may have to change the sensitivity
                        for specfic programs to get them to work.)

                =>      Sentry(EXTENDED_KEYBOARD,YES)
                        (Tells the tsr computer bios supports an
                        extended keyboard. If the bios does not support
                        an extended keyboard then the tsr CAN NOT shove
                        characters into the keyboard buffer. The tsr
                        automatically checks for extended keyboard
                        capability. However on some clones the tsr
                        may guess wrong. If a bios does not support
                        an extended keyboard then the tsr will HALT
                        the system when a user shells to dos. You
                        use this command to EXPLICITLY tell the tsr
                        if an extended keyboard is supported. See
                        ASK_FOR below to query the tsr for the
                        current settings)

                =>      Sentry(EXTENDED_KEYBOARD,NO)

                =>      Sentry(ASK_FOR,setting)
                        (Query tsr for any of the above settings.
                        example:

                        Sentry(ASK_FOR,DENY_DOS_ACCESS)
                        (returns YES or NO)

                        Sentry(ASK_FOR,SET_PROTECTION_SENSITIVITY)
                        (returns the current protection setting)

                =>      Sentry(DOS_EXIT_COUNT,0)
                        (set exit count to zero)

                        Sentry(ASK_FOR,DOS_EXIT_COUNT)
                        (what is the current count?
                        The Sentry will count how many times it took
                        action against a user. Namely how many times
                        the user exited to dos and the sentry caught him.
                        Use this command to retrieve that information.)

                =>      Sentry(USER_DEFINED1,xx)
                        Sentry(USER_DEFINED2,xx)
                        Sentry(USER_DEFINED3,xx)
                        Sentry(USER_DEFINED4,xx)

                        (User defined values. Use
                        Sentry(ASK_FOR,USER_DEFINEDx) to retrieve value

                !***


                   SetSentryExitCommand(ULONG),SHORT,NAME('_SetSentryExitCommand')
                   GetSentryExitCommand(ULONG),SHORT,NAME('_GetSentryExitCommand')

                OMIT('!***')

                   Changes/Gets the command to SHOVE into the keyboard buffer
                   eg:

                        NewCommand      PSTRING(20)
                        Address         ULONG

                        NewCommand='RUNME'              !instead of exit
                        Address=ADDRESS(NewCommand)
                        SetSentryExitCommand(Address)

                        Address=ADDRESS(NewCommand)
                        GetSentryExitCommand(Address)
                        stop('= '&NewCommand)           ! Displays RUNME

                   The new command MUST NOT EXCEED 20 characters or the TSR
                   will behave eratically (in fact you'll probably have the
                   system hang)


===========================================================================
                New-Tech special drive protection functions
===========================================================================

        Floppy drives and Hard drives can be protected from reads and/or
        writes. Although it appears that the read/write was successful
        the protected drive is unaffected. It is IMPORTANT to remember
        to disable these settings for low-level programs that directly
        access the drive such as defrag or diskfix software. The sentry
        protection works through all dos programs (including low-level
        format and defrag) as well as Windows.


                =>      Sentry(DISABLE_WRITE_DRIVE_A,YES)
                        Sentry(DISABLE_WRITE_DRIVE_B,YES)
                        Sentry(DISABLE_WRITE_DRIVE_C,YES)
                        Sentry(DISABLE_WRITE_DRIVE_D,YES)

        Drives protected can be read but NOT written to. This prevents
        users from deleting files from the drive AND formatting of the
        drive and any other write-to-drive requests you can think of.
        Remember not to protect drives with programs who write files
        to the drive! (for example Windows).

                =>      Sentry(DISABLE_READ_TO_DRIVE_A,YES)
                        Sentry(DISABLE_READ_TO_DRIVE_B,YES)
                        Sentry(DISABLE_READ_TO_DRIVE_C,YES)
                        Sentry(DISABLE_READ_TO_DRIVE_D,YES)

        Prevents read access to the drive. Disabling read access to a
        drive automatically disables the write access to that drive
        regardless of the current DISABLE_WRITE_DRIVE_x setting.

                =>      Sentry(PROTECT_PARTITION_TABLE_C,YES)
                        Sentry(PROTECT_PARTITION_TABLE_D,YES)

        Prevents any changes to the hard drives' partition table.
        (floppy drives dont have partition tables!)

                =>      Sentry(PROTECT_BOOT_RECORD_ON_A,YES)
                        Sentry(PROTECT_BOOT_RECORD_ON_B,YES)

        Stop users/software(viruses?) from changing the floppy drives
        boot record. Protecting the hard drives' boot record (C & D) is
        accomplished through a seperate library function.

                =>      Sentry(ENABLE_READ_WRITE_TRAP,YES)

        Tells the sentry to start protecting the Drives you requested.
        Here is an example:

                Sentry(ENABLE_READ_WRITE_TRAP,NO)  ! turn trapping off

                Sentry(PROTECT_BOOT_RECORD_ON_A,YES)
                Sentry(PROTECT_BOOT_RECORD_ON_B,YES)
                Sentry(PROTECT_PARTITION_TABLE_C,YES)
                Sentry(PROTECT_READ_DRIVE_D,NO)

                Sentry(ENABLE_READ_WRITE_TRAP,YES) ! turn trapping on


                   !***


                ProtectBootRecord(USHORT,USHORT),USHORT,NAME('_ProtectBootRecord')

        OMIT('!***')

        =>      ProtectBootRecord(Physical Drive,Partition#)

        This function protects the boot records on hard drives C & D.
        The same precautions apply here as they did with protecting
        Partition tables. You must specify the PHYSICAL DRIVE to protect
        (C or D) and the partition. Here are some examples

        example 1: protecting Boot record on Drive C with one partition

                Sentry(ENABLE_READ_WRITE_TRAP,NO)  ! Turn all trapping off

                ProtectBootRecord(DRIVE_C,1)  ! Drive C, 1st partition

                Sentry(ENABLE_READ_WRITE_TRAP,YES) ! start trapping

                Sentry(ASK_FOR,PROTECT_BOOT_RECORD_ON_C) ! returns YES
                Sentry(PROTECT_BOOT_RECORD_ON_C,NO)  ! turns OFF protection

        example 2: protecting boot record on physical drive D partition f.
                   The drive is partioned into logical drives D,E,F, and G

                ProtectBootRecord(DRIVE_D,3)   ! 1=logical drive d, 2=drive E ...

        !***

                DontProtectBootRecord(USHORT,USHORT),USHORT,NAME('_DontProtectBootRecord')
                GetBootProtectInfo(USHORT),USHORT,NAME('_GetBootProtectInfo')
                ResetBootRecordProtection(USHORT),USHORT,NAME('_ResetBootRecordProtection')
                ProtectEntirePartition(USHORT,USHORT,USHORT),USHORT,NAME('_ProtectEntirePartition')
                GetPartitionProtectInfo(USHORT),USHORT,NAME('_GetPartitionProtectInfo')


                MapDirFromTo(USHORT,USHORT,ULONG,ULONG),USHORT,NAME('_MapDirFromTo')
                GetRemapDirPaths(USHORT,ULONG,ULONG),USHORT,NAME('_GetRemapDirPaths')
                SuspendDirRemaps(),USHORT,NAME('_SuspendDirRemaps')
                RestoreDirRemaps(),USHORT,NAME('_RestoreDirRemaps')
                UnMapDir(USHORT),USHORT,NAME('_UnMapDir')
                SaveMaps(USHORT),USHORT,NAME('_SaveMaps')
                MountDirectories(),USHORT,NAME('_MountDirectories')
                GiveAccess(USHORT),USHORT,NAME('_GiveAccess')
                TakeAccess(USHORT),USHORT,NAME('_TakeAccess')
                Mount(),USHORT,NAME('_Mount')
                UnMount(),USHORT,NAME('_UnMount')

                CreateClaTemp(),NAME('_CreateClaTemp')


        OMIT('!***')

        =>      DontProtectBootRecord(Physical Drive X,Partition Y)

        Opposite of above function. Stop protecting the boot record
        on physical drive X, partition Y


        =>      ResetBootRecordProtection(Physical drive)

        Stops boot record protection for the drive on all partitions

        =>      GetBootProtectInfo(Physical Drive X)

        Function returns which partitions' boot records are being
        protected as follows:

                if return value=10
                in binary->
                                bit     3       2       1       0
                                =================================
                                        1       0       1       0
                                        ^       ^       ^       ^
                                        |       |       |       |
                                        |       |       |  Partition #1
                                        |       |  Partition #2
                                        |  Partition #3
                                   Partition #4

                in this example the boot records on partition 4 and 2
                are set to be protected.


        If your drive is partitioned into logical volumes then you can
        read and/or write protect those individual partitions:

                =>      ProtectEntirePartition(Drive,Partition,Action)

        Where   Drive           =       DRIVE_C or DRIVE_D
                Partition       =       1,2,3,4
                Action          =       READ_PROTECT (implies write protect)
                                =       WRITE_PROTECT
                                =       RESTORE (normal read/write access)

                eg: Protect 3rd partition on drive D from READ/WRITE access

                        ProtectEntirePartition(DRIVE_D,3,READ_PROTECT)

                eg: Give read access but not writes on C partition 2

                        ProtectEntirePartition(DRIVE_C,2,WRITE_PROTECT)

        Asking for Partition information:

                =>      GetPartitionProtectInfo(Drive)

        This function returns an 8 bit value where the lower 4 bits
        indicate which partitions have read/write protection; the
        upper 4 gives which have write protection.

                eg: if the return value is 134 then ...

                  write protection bits            read protection bits
        bit     7       6       5       4       3       2       1       0
                =========================       =========================
                1       0       0       0       0       1       1       0
                ^       ^       ^       ^       ^       ^       ^       ^
                |       |       |       |       |       |       |       |
                |       |       |   Partition 1 |       |       | Partition 1
                |       |   Partition 2         |       |   Partition 2
                |  Partition 3                  |   Partition 3
            Partition 4                    Partition 4

            in this example Partitions 2 and 3 have read/write protection ;
            4 has write protection and 1 has no protections at all.

============================================================================
                            DIRECTORY REMAPPING
============================================================================
You can deny users access to certain directories by redirecting them to
unimportant (or dummy) directories. CAUTION: Do not run SCANDISK or other
diskfix utilities. They WILL detect errors and if you allow them to
go ahead with the "FIX" you will loose those remapped directories. Also
avoid programs that can change the order of directories or move them entirely
to a different subdirectory. Executing a DELTREE command on a mapped
directory will delete BOTH the mapped and original directory. To avoid
these problems disable "directory remapping" before running such programs ...


                =>      Handle=MapDirFromTo(drive X,partition Y,From,To)

                Maps the directory on drive X, partition Y to an
                alternate directory on the same drive. The From and To
                parameters are entire PATHS from the root to the directories
                to remap. They MUST not start with '\'. It is implied to
                start looking for these directories from the root. The
                function returns a HANDLE to the remapped directories which
                can be used in other function calls. An example should
                make things alot clearer ....

        DirHandle       USHORT
        buffer          PSTRING(128)    ! strings MUST BE declared
        buffer2         PSTRING(128)    ! as pascal strings!
        Address         ULONG
        Address2        ULONG


        ! Directory to be mapped somewhere else. NOTICE the path is
        ! WINDOWS\NETSCAPE and not \WINDOWS\NETSCAPE. The function
        ! will fail if you add the '\'

        buffer='WINDOWS\NETSCAPE'

        ! Redirect to the directory 'TEMP\USER' (again notice the
        ! missing '\')

        buffer2='TEMP\USER'

        ! Ok we need the ADDRESS of these strings to pass to the sentry

        Address=ADDRESS(buffer)
        Address2=ADDRESS(buffer2)

        ! Remap \WINDOWS\NETSCAPE to \TEMP\USER on drive C, 1st partition

        DirHandle=MapDirFromTo(DRIVE_C,1,Address,Address2)

        RETURN

Changing to the directory \WINDOWS\NETSCAPE will actually send you into
the \TEMP\USER directory. Adding or deleting files will affect the
\TEMP\USER directory. The NETSCAPE directory will remain unaffected.


                =>      UnMapDir(dirHandle)

                As the name implies removes the mapping associated
                with the dirHandle. NOTE: directory handles are
                numbered 1,2,3,4,5... If you unmap a directory
                all handles below it move up one. This is important
                to remember if your program maintains a list of
                directory handles. For example if you remap 8 directories
                the directory handles returned will be:

                        1,2,3,4,5,6,7, and 8 respectively

                if you UnMap handle 4 then handles 1,2,3 still reference
                the same directories but 5,6,7,and 8 move up one spot.
                So directory handle 5 now becomes 4, 6 becomes 5,
                7 becomes 6, and 8 becomes 7! Here is an example

                ...
                !assume this is the FIRST directory mapped
                ! ha will equal 1

                        Ha1=MapDirFromTo(DRIVE_C,1,From1,To1)


                !assume this is the SECOND. ha2 will be 2!
                        ha2=MapDirFromTo(DRIVE_C,1,From2,To2)

                !unmap 1st directory
                        UnMapDir(Ha1)

                !unmap 2nd directory
                        UnMapDir(Ha2)  ! WROOOOONG unmapping the first
                                       ! directory (1) moved all that
                                       ! came after it up one spot.
                                       ! The handle to the second
                                       ! directory is actually now 1

        The UnMapDir function allows you to selectively unmap directories.
        There is a library function available to unmap ALL directories
        at once. (so your program doesn't have to save all the handles
        and unmap them one by one!)

                =>      SuspendDirRemaps()
                =>      RestoreDirRemaps()

        SuspendDirRemaps undoes all directory mappings. RestoreDirRemaps()
        places the directory mapping back to the way it was BEFORE they
        were suspended. Do not issue a RestoreDirRemaps() function if
        you haven't suspended the drive mappings (SuspendDirRemaps).
        If you map a directory after the SuspendDirRemaps() command. The
        directory mapping table is cleared ; DO NOT use
        RestoreDirRemaps(). Here is an example:



                SuspendDirRemaps()      ! turns off all directory re-maps


                ... your code here ...


                RestoreDirRemaps()      ! all directory remaps suspended by
                                        ! SuspendDirRemaps are now back !!!

                MapDirFromTo(DRIVE_C,1,From,To) ! lets add another directory
                                                ! mapping to the current list
                                                ! of directories being mapped

                ... your code here ...

                SuspendDirRemaps()      ! turn it off again

                MapDirFromTo(DRIVE_D,1,From,To)

                        ! because you turned all mappings off this
                        ! command starts a new mapping. The table that
                        ! was saved when you called SuspendDirRemaps()
                        ! is now forgotten and replaced by this single
                        ! entry. At this point your only remapping one
                        ! directory

                RestoreDirRemaps() ! DOOON'T DO THIS!!! The table that
                                   ! was saved when SuspendDirRemaps was
                                   ! called is no longer valid. Your program
                                   ! will behave eratically and crash!!!


                RETURN

                             ~~~~~~~~~~~~~~~~

                =>      drive=GetRemapDirPaths(handle,From,To)

(input) handle=Directory handle you want information on.

(input/output)
        From=address of buffer to store path of directory being remapped.
        To=address of buffer to store the path of where the directory is
           remapped to.

(output)
        drive=The drive this mapping is on (C or D)

        An example should clear things up ...


                buffer          PSTRING(128)
                buffer2         PSTRING(128)
                Address         ULONG
                Address2        ULONG

                ! assuming the DirHandle variable is from the FIRST
                ! example (map \WINDOWS\NETSCAPE to \TEMP\USER)

                Address=ADDRESS(buffer)
                Address2=ADDRESS(buffer2)

                drive=GetRemapDirPaths(DirHandle,Address,Address2)

                ! drive now contains the value DRIVE_C

                stop('From=' &buffer)  ! displays WINDOWS\NETSCAPE
                stop('To=' &buffer2)   ! displays TEMP\USER

                           ~~~~~~~~~~~~~~~~~~~
        Note: If directory mappings are suspends (SuspendDirRemaps) then
        the above function (GetRemapDirPaths) will fail.


                =>      Sentry(ASK_FOR,CURRENT_DIR_REMAPS)
                        Sentry(ASK_FOR,MAXIMUM_DIR_REMAPS)

        Queries the sentry for the number of directories currently
        being mapped and the maximum number of directories that can
        be mapped respectively ...



                =>      SaveMaps(Table Entry#)

        Use this command to change a mapping from a temporary to a
        saved one.

                =>      GiveAccess(Table Entry#)

        Gives access to a saved map without removing the protection.

                =>      TakeAccess(Table Entry#)

        Removes access granted by give

                =>      MountDirectories()
        
        Tells the Sentry about all the currently saved maps. This
        information is read from a file called DIRDATA. You must
        execute this command before you can do anything with 
        saved maps. (ie: unmap,give access, take access, etc ...)

                => UnMount()

        Similiar to Suspend() but for saved maps. The mapping is
        removed from both memory and the hard drive (affects only
        saved maps).

                => Mount()

        Similiar to Restore() ; The mappings removed from UnMount
        are placed back.












        !***
        .
